<?php
/*
Plugin Name: Social Media Monitoring
Plugin URI: http://www.alreadycoded.com
Description: This plugin will display the social media popularity of wordpress posts.
Version: 1.0
Author: AlreadyCoded
Author URI: http://www.alreadycoded.com
License: GPL
*/

error_reporting(0);
set_time_limit(0);


function file_get_contents_curl($url) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);    
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);    
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    $data = curl_exec($ch);
    curl_close($ch);
 
    return $data;
}
	
function get_facebook_stats_count($url)
{
	$en_link = urlencode($url);
	
	$data 	= file_get_contents_curl("https://graph.facebook.com/?fields=share&ids=$en_link");
	$json 	= json_decode($data,true);
	$like_count 	= isset($json[$url]['share']['share_count']) ? $json[$url]['share']['share_count'] : '0';
	$share_count 	= isset($json[$url]['share']['share_count']) ? $json[$url]['share']['share_count'] : '0';
	$comment_count 	= isset($json[$url]['share']['comment_count']) ? $json[$url]['share']['comment_count'] : '0';
	$total_count = $share_count + $comment_count;
	$click_count = "";				
    $fb = array(
    'likes' => $like_count,
    'shares' => $share_count,
    'comments' => $comment_count,
    'total' => $total_count,
    'clicks' => $click_count                
    );
 	return $fb;

}

if ( is_admin() ){

add_action('admin_menu', 'social_media_monitoring_admin_menu');

function social_media_monitoring_admin_menu() {
add_menu_page('Social Media Monitoring', 'Social Media Monitoring', 'administrator',
'social_media_monitoring', 'social_media_monitoring_html_page');
}
}

function social_media_monitoring_html_page() {
			
?>
<table width="100%" border="1">
<tr>
	<th width="40%" align="left">
	Post Link
	</th>
	<th width="20%" align="center">
	Date Published
	</th>	
	<th width="20%" align="center">
	Facebook Likes / Shares
	</th>		
	<th width="20%" align="center">
	Facebook Comments
	</th>
</tr>	
<?php
	global $wpdb;
	$page_num = isset( $_GET['pagenum'] ) ? absint( $_GET['pagenum'] ) : 1;
	$limit = 20;
	$offset = ( $page_num - 1 ) * $limit;
	$total = $wpdb->get_var( "SELECT COUNT(`id`) FROM `wp_posts` WHERE `post_status` = 'publish'" );
	$num_of_pages = ceil( $total / $limit );
	$lists = $wpdb->get_results("SELECT * FROM `wp_posts` WHERE `post_status` = 'publish' ORDER BY id DESC LIMIT $offset,$limit");
	
	foreach($lists as $list){

	$title = $list->post_title;
	$post_url = get_permalink($list->ID);
	$post_date = strtotime($list->post_date);
?>
<tr>
<?php	
	
	$fb = get_facebook_stats_count($post_url);		

?>

	<td>
	<a href="<?php echo $post_url; ?>" target="_blank"><?php echo $title; ?></a>
	</td>
	<td align="center">
	<?php echo date('F j, Y',$post_date); ?>
	</td>	
	<td align="center">
	<?php echo number_format($fb['shares']); ?>
	</td>		
	<td align="center">
	<?php echo number_format($fb['comments']); ?>
	</td>
	</tr>
<?php 
	}

?>
</table>
<?php
$page_links = paginate_links( array(
'base' => add_query_arg( 'pagenum', '%#%' ),
'format' => '',
'show_all' => true,
'prev_text' => __( '', 'text-domain' ),
'next_text' => __( '', 'text-domain' ),
'total' => $num_of_pages,
'current' => $pagenum
) );

if ( $page_links ) {
echo '<br /><br /><br /><div class="tablenav" style="float:left;"><div class="tablenav-pages">' . $page_links . '</div></div>';
}
}
?>